Bug 454277 - (CVE-2008-2950) CVE-2008-2950 poppler: uninitialized pointer free (oCERT-2008-007)
CVE-2008-2950 poppler: uninitialized pointer free (oCERT-2008-007)
Status: CLOSED ERRATA
Product: Security Response
Classification: Other
Component: vulnerability (Show other bugs)
unspecified
All Linux
high Severity high
: ---
: ---
Assigned To: Red Hat Product Security
source=vendor-sec,reported=20080628,p...
: Security
Depends On: 454288 454289 454290
Blocks:
  Show dependency treegraph
 
Reported: 2008-07-07 09:18 EDT by Tomas Hoger
Modified: 2008-09-11 13:19 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-09-11 13:19:27 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Proposed patch (400 bytes, patch)
2008-07-07 09:19 EDT, Tomas Hoger
no flags Details | Diff

  None (edit)
Description Tomas Hoger 2008-07-07 09:18:33 EDT
Quoting upcoming oCERT advisory:

The poppler PDF rendering library suffers a memory management bug which leads
to arbitrary code execution.

The vulnerability is present in the Page class constructor/destructor. The
pageWidgets object is not initialized in the Page constructor if specific
conditions are met, but it is deleted afterwards in the destructor regardless
of its initialization.

oCERT advisory credits: Felipe Andres Manzano

Advisory:
http://www.ocert.org/advisories/ocert-2008-007.html
Comment 1 Tomas Hoger 2008-07-07 09:19:51 EDT
Created attachment 311147 [details]
Proposed patch
Comment 5 Tomas Hoger 2008-07-07 11:03:19 EDT
This issue did not affect version of poppler as shipped in Red Hat Enterprise
Linux 5, or other PDF parsing applications derived from xpdf as shipped in Red
Hat Enterprise Linux 2.1, 3, 4, and 5.
Comment 6 Tomas Hoger 2008-07-09 08:04:58 EDT
Detailed description and public PoC by Felipe Andres Manzano:

  http://marc.info/?l=full-disclosure&m=121556059918963&w=4
Comment 7 Fedora Update System 2008-08-01 06:10:39 EDT
poppler-0.6.2-2.fc8 has been submitted as an update for Fedora 8
Comment 8 Fedora Update System 2008-08-01 06:10:57 EDT
poppler-0.8.1-2.fc9 has been submitted as an update for Fedora 9
Comment 9 Fedora Update System 2008-08-07 19:50:34 EDT
poppler-0.8.1-2.fc9 has been pushed to the Fedora 9 testing repository.  If problems still persist, please make note of it in this bug report.
 If you want to test the update, you can install it with 
 su -c 'yum --enablerepo=updates-testing update poppler'.  You can provide feedback for this update here: http://admin.fedoraproject.org/updates/F9/FEDORA-2008-7012
Comment 10 Fedora Update System 2008-08-07 19:57:49 EDT
poppler-0.6.2-2.fc8 has been pushed to the Fedora 8 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 11 Tomas Hoger 2008-09-03 06:41:25 EDT
To further extend comment #5:

As detailed in Felipes advisory [1], this issue occurs when pageWidgets with uninitialized value is freed in Page::~Page() destructor.  pageWidgets was only introduced in poppler in (or around) upstream version 0.6.  The code does not exist in the xpdf, on which poppler is based.

[1] http://marc.info/?l=full-disclosure&m=121556059918963&w=4
    http://www.milw0rm.com/exploits/6032
Comment 12 Fedora Update System 2008-09-11 13:07:14 EDT
poppler-0.8.1-2.fc9 has been pushed to the Fedora 9 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 13 Red Hat Product Security 2008-09-11 13:19:27 EDT
This issue was addressed in:

Fedora:
  https://admin.fedoraproject.org/updates/F8/FEDORA-2008-7104
  https://admin.fedoraproject.org/updates/F9/FEDORA-2008-7012

Note You need to log in before you can comment on or make changes to this bug.